<?
/*
YaotGui configuration.


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

class Settings
{
   /// The scripts will be allowed to get any file from inside these paths
   /// Please specify both original and translated path if you use path translating for VLC
   public static $ALLOWED_PATHS = array('/home/stu/Videos/flvvideo', '/media', 'c:/mydir');

   /// The IPs that are allowed to access these pages
   public static $ALLOWED_IPS = array('192.168.178.31', '127.0.0.1','192.168.178.20','192.168.178.32');

   /// Main menu path (used by sub-menus)
   const MAIN_MENU_PATH = 'menu.php';
   /// Items to show in the main menu
   public static $MAIN_MENU = array('Videos' => 'video.php', 'Images' => 'image.php');

   /// The image to show when the requested image can't be found/is not allowed to be viewed
   const INVALID_IMAGE = 'images/noimg.png';

   /// Favorite image folders (will be shown in 'Images' menu)
   public static $IMAGE_FAVS = array('pics' => 'mypics', 'test' => 'test/images');

   /// Favorite video folders (will be shown in 'Videos' menu)
   public static $VIDEO_FAVS = array('vids' => '/home/stu/Videos/flvvideo', 'Other vids' => '/media/');

   /// Address to VLC HTTP interface
   const VLC_HTTP = '192.168.178.20:8080';
   /// Address to stream from
   const VLC_STREAM = '192.168.178.20:5555';
   /// The time to wait in millisecs between requesting a video and opening it
   /// Adjust this value if the video never starts playing when you select it
   const STREAM_DELAY = 0;

   /// Translate the folder names if vlc runs on another computer
   public static $VLC_FOLDER_TRANSLATE = array('/home/vids' => '//computer/share/vids',
					       '/mnt/otherpc/c' => 'c:');
   /// Are we translating to Windows paths? (ie VLC is running on Windows)
   const VLC_FOLDER_TRANSLATE_TO_WIN = false;

   /// How long shall VLC skip when skipping? examples: 2min, 5sec
   const VLC_SHORT_SKIP = '30sec';
   const VLC_LONG_SKIP = '5min';

   /// File filter for image types supported by the browser
   const IMAGE_FILTER = '/.(?:png|jpg|jpeg|gif|bmp|svg)/i';
   /// File filter for video formats supported by VLC
   const VIDEO_FILTER = '/.(?:mpg|mpeg|avi|asf|wmv|mp4|mov|3gp|ogv|ogm|mkv|flv|xspf|)/i';
}

class TV
{
   const LEFT = 30;
   const TOP = 20;
   const WIDTH = 660;
   const HEIGHT = 540;
}
?>
