<?php
/*
YaotGui Get Image


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

require('lib.php');

function getFileType($file)
{
   return strtolower(substr($file, strrpos($file, '.') + 1));
}

if(isset($_GET['src']))
{
//more problematic chars?
$src = str_replace('\\\'', '\'', $_GET['src']);

// '..' in path would allow an evil user to get out of our path jail!
if(!isInAllowedPath($src) || !file_exists($src))
   $src = Settings::INVALID_IMAGE;
}
else
   $src = Settings::INVALID_IMAGE;

$resize = false;
$keepRatio = isset($_GET['keep_ratio']);
$newImgW = 0;
$newImgH = 0;
if(isset($_GET['width']) && isset($_GET['height']))
{
   $resize = true;
   $newImgW = $_GET['width'];
   $newImgH = $_GET['height'];
}

header("Content-Transfer-Encoding: binary");

$fileType = getFileType($src); //should get MIME, but slower
header("Content-Type: image/$fileType\n");

if($resize)
{
   switch($fileType)
   {
      case 'png':
	 $img = imagecreatefrompng($src);
	 break;
      case 'jpg':
      case 'jpeg':
	 $img = imagecreatefromjpeg($src);
	 break;
      case 'gif':
	 $img = imagecreatefromgif($src);
	 break;
      default:
	 //We can't do anything, just pass through
	 $resize = false;
   }
}

if($resize)
{
   $imgW = imagesx($img);
   $imgH = imagesy($img);

   if($keepRatio)
   {
      $ratio = min($newImgW / $imgW, $newImgH / $imgH);
      $newImgW = $ratio * $imgW;
      $newImgH = $ratio * $imgH;
   }

   $newImg = imagecreatetruecolor($newImgW, $newImgH);
   //resample is better but much slower
//   imagecopyresampled($newImg, $img, 0, 0, 0, 0, $newImgW, $newImgH, $imgW, $imgH);
                   // Turn off transparency blending (temporarily)
                imagealphablending($newImg, false);
   
                // Create a new transparent color for image
                $color = imagecolorallocatealpha($newImg, 0, 0, 0, 127);
   
                // Completely fill the background of the new image with allocated color.
                imagefill($newImg, 0, 0, $color);
   
                // Restore transparency blending
                imagesavealpha($newImg, true);
   imagecopyresized($newImg, $img, 0, 0, 0, 0, $newImgW, $newImgH, $imgW, $imgH);

   switch($fileType)
   {
      case 'png':
	 imagepng($newImg);
	 break;
      case 'jpg':
      case 'jpeg':
	 imagejpeg($newImg);
	 break;
      case 'gif':
	 imagegif($newImg);
	 break;
   }
}
else
{
/*   $file = fopen($src, "r");
   if($file)
      fpassthru($file);
      fclose($file);*/
   readfile($src);
}

?>
