<?php
/*
YaotGui Images page


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/
   
require('lib.php');
$showFavs = true;
$path;
if(isset($_GET['path']))
{
   $path = str_replace('\\\'', '\'', $_GET['path']);
   $showFavs = !isInAllowedPath($path);
}

$titlePath;
if($showFavs)
{
   $dir = new LibList('favs', 'favs');
   foreach(Settings::$IMAGE_FAVS as $text => $path)
   {
      $dir->addItem(array('type' => 'dir', 'path' => $path), $text);
   }
	
   $titlePath = 'Images';
}
else
{
   $directory = new LibDirectory($path, Settings::IMAGE_FILTER);
   $dir = new LibDirectoryImageList('dir', 'dir', 4, 120, 120, $directory,
				    'images/folder.png', 'images/file.png', true, 'images/up.png');
   $titlePath = $dir->getDirectory()->getParentPath() . '/<span class="big">' . $dir->getDirectory()->getName();
}

$dir->sort();
?>
<html>
<head>
<?php
JSLib();
defaultStyles();
?>
<style>
body {background: #000000; color: #ffffff; font-family: Sans-serif; font-size: 20px;
      position: absolute; left: <?php echo TV::LEFT?>px; top: <?php echo TV::TOP?>px; width: <?php echo TV::WIDTH?>px; height: <?php echo TV::HEIGHT?>px; overflow: auto;}
#fullscreen {position: absolute; left: 0px; top: 0px; width: <?php echo TV::WIDTH?>px; height: <?php echo TV::HEIGHT?>px; display: none; background: #000; text-align: center;}
#fullscreen_img {background: silver url(images/trans.png); position: relative;}
#fullscreen_text {display: none; position: absolute; top: 20px; left: 20px;}
#fullscreen_text_fg {color: #fff; position: absolute; top: 0px; left: 0px;}
#fullscreen_text_bg {color: #000; position: absolute; top: 1px; left: 1px;}
#path {overflow: hidden; white-space: nowrap; position: absolute; left: 25px; top: 2px; width: <?php echo TV::WIDTH-2*25;?>px;}
.dir, .favs {position: absolute; left: 25px; top: 35px; width: <?php echo TV::WIDTH-2*25;?>px; height: <?php echo TV::HEIGHT-2*35;?>px;}
.dir_img {background: silver url(images/trans.png);}
#status {position: absolute; background: #555; color: #fff; width: 200px; height: 50px; top: <?php echo (TV::HEIGHT-50)/2; ?>px; left: <?php echo (TV::WIDTH-200)/2; ?>px; text-align: center;}
</style>
<script>
var _fullscreen = false;
var _info = false;
var TV_WIDTH = <?php echo TV::WIDTH?>;
var TV_HEIGHT = <?php echo TV::HEIGHT?>;
<?php if(!$showFavs) { ?>
var _sizeImg = new Image(); //used to measure image size
var _preloadImg = new Image(); //try to predict and preload the next image
_sizeImg.onload = sizeLoaded;
var _slideshow = false;
var _slideshowTimer;
<?php } ?>
		      
function load()
{
   if(!_debugMode)
   {
        toiEnv.input.addEventListener(toiEnv.input.ON_KEY_DOWN, userinput);
   }

   document.getElementById('status').style.display = 'none';

    <?php if(!$showFavs) { ?>
    preloadImage(0, 1);
    <?php } ?>
}

function userinput (event)
{
        var key = event.extendedKeyCode;
        event.consume();
	onKey(key);
}

function onKey(key)
{
    try
    {
        switch (key)
        {
	    //boot loader
	case 7733366: //BTN_YELLOW
	    var newLocation = "/iptvgui/initial.html";
	    top.location = newLocation;
	    break;
    	case BTN_MENU:
	    top.location = '<?php echo Settings::MAIN_MENU_PATH; ?>';
	    break;
	case BTN_QUESTIONMARK:
	    location.reload();
	    break;
<?php if($showFavs) { ?>
	case BTN_MIDUP:
	    __favs_move(-1, true);
	    break;
	case BTN_MIDDN:
	    __favs_move(1, true);
	    break;
	case BTN_MIDOK:
	    goToDir(__favs_getSelectedValue('path'));
	    break;
	case BTN_PPLUS:
	    __favs_move(-5, 0, false);
	    break;
	case BTN_PMINUS:
	    __favs_move(5, 0, false);
            break;
<?php } /*$showFavs*/ ?>
<?php if(!$showFavs) { ?>
	case BTN_MIDUP:
	    if(!_fullscreen)
		__dir_move(-1, 0, true);
	    break;
	case BTN_MIDDN:
	    if(!_fullscreen)
		__dir_move(1, 0, true);
	    break;
	case BTN_MIDRT:
	    pauseSlideshow();
	    __dir_move_idx(1, true);
	    if(_fullscreen)
	    {
		showImageStep(1);
	    }
	    break;
	case BTN_MIDLT:
	    pauseSlideshow();
	    __dir_move_idx(-1, true);
	    if(_fullscreen)
	    {
		showImageStep(-1);
	    }
	    break;
	case BTN_MIDOK:
	    if(!_fullscreen)
	    {
	       switch(__dir_getSelectedValue('type'))
	       {
		  case 'file':
		     showFullscreen();
		     break;
		  case 'dir':
		     goToDir(__dir_getSelectedValue('path'));
		     break;
	       }
	    }
	    else
	    {
		stopSlideshow();
//		hideFullscreen();
	    }
	    break;
	case BTN_PPLUS:
	    __dir_move(-5, 0, false);
	    break;
	case BTN_PMINUS:
	    __dir_move(5, 0, false);
	    break;
	case BTN_INFO:
	    if(!_info)
	    {
		document.getElementById('fullscreen_text').style.display = 'block';
		_info = true;
	    }
	    else
	    {
		document.getElementById('fullscreen_text').style.display = 'none';
		_info = false;
	    }
	    break;
	case BTN_PP:
	    playPauseSlideshow();
	    break;
	case BTN_STOP:
	    stopSlideshow();
	    break;
<?php } /*!$showFavs*/ ?>
	default:
//	    alert(key);
	    break;
        }
    }
    catch(err)
    {
	alert(err.message);
    }
}

function goToDir(path)
{
   window.location = '?path=' + escape(path);
}

<?php if(!$showFavs) { ?>
function playPauseSlideshow()
{
    if(!_slideshow)
    {
	playSlideshow();
    }
    else
    {
	pauseSlideshow();
    }
}

function nextSlide()
{
    if(_slideshow)
    {
	__dir_move_idx(1, true);
	showImageStep(1);
    }
}

function playSlideshow()
{
    showFullscreen();
    clearInterval(_slideshowTimer);
    _slideshowTimer = setInterval(nextSlide, 5000);
    _slideshow = true;
}

function pauseSlideshow()
{
    clearInterval(_slideshowTimer);
    _slideshow = false;
}

function stopSlideshow()
{
    pauseSlideshow();
    hideFullscreen();
}

function showFullscreen()
{
    if(_fullscreen)
	return;
    
    var prevIdx = __dir_selectedIndex;
    while(__dir_getSelectedValue('type') != 'file')
    {
	__dir_move_idx(1, true);
	if(__dir_selectedIndex == prevIdx)
	    return;
    }
    
    document.getElementById('fullscreen').style.display = 'block';
    var img = document.getElementById('fullscreen_img');
    img.src = 'images/file.png';
    //		img.style.display = 'none';
    showSelectedImage();
    _fullscreen = true;
    preloadImage(1, 1);
}

function hideFullscreen()
{
    _fullscreen = false;
    document.getElementById('fullscreen').style.display = 'none';
}

function showImageStep(step)
{
    while(__dir_getSelectedValue('type') != 'file')
    {
	__dir_move_idx(step, true);
    }
    showSelectedImage();
    preloadImage(step, step);
}

function preloadImage(startOffset, step)
{
    prevIdx = __dir_selectedIndex;
    idx = lib_control_itemStep(prevIdx, startOffset, __dir_itemCount, true);
    while(__dir_getValue(idx, 'type') != 'file')
    {
	idx = lib_control_itemStep(idx, step, __dir_itemCount, true);
	if(idx == prevIdx)
	   return;
    }
    _preloadImg.src = createImageUrl(__dir_getValue(idx, 'path'));
}

function showSelectedImage()
{
    var src = createImageUrl(__dir_getSelectedValue('path'));

    _sizeImg.src = src;
    var img = document.getElementById('fullscreen_img');
    img.src = src;
    fixImageSize();

    var txt = __dir_getSelectedValue('text');
    document.getElementById('fullscreen_text_fg').firstChild.nodeValue = txt;
    document.getElementById('fullscreen_text_bg').firstChild.nodeValue = txt;
}

function createImageUrl(path)
{
    return 'getImg.php?src=' + path + '&keep_ratio=1&width=' + TV_WIDTH + '&height=' + TV_HEIGHT;
}

//this will not work if the image was already preloaded
/*function imageLoaded()
{
    //image is hidden before it has been loaded as the browser will show the last image => confuse the user when entering fullscreen
    var img = document.getElementById('fullscreen_img');
    img.style.display = 'inline';
}*/

//this event only happens when the image was not already cached!
function sizeLoaded()
{
   fixImageSize();
}

function fixImageSize()
{
    var img = document.getElementById('fullscreen_img');
    var factor;
    factor = Math.min(TV_WIDTH / _sizeImg.width, TV_HEIGHT / _sizeImg.height);
    img.width = factor * _sizeImg.width;
    img.height = factor * _sizeImg.height;
    //seems like neither vertical-align nor margin: auto; want to work, so lets use some positions!
    img.style.top = (TV_HEIGHT - img.height) / 2;
}
<?php } /*!$showFavs*/ ?>

function debugKey(e)
{
if(!e)
e = window.event;

onKey(e.keyCode);
}

document.onkeyup = debugKey;
</script>
</head>
<body onload="load()">
     <div id="path"><?php echo $titlePath;?></span></div>

    <?php $dir->printHtml(); ?>
  <div id="fullscreen"><img id="fullscreen_img"><div id="fullscreen_text"><span id="fullscreen_text_bg">info</span><span id="fullscreen_text_fg">info</span></div></div>
  <div id="status">Loading...</div>
</body>
</html>
