/*
YaotGui javascript helper functions


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

SCROLLBAR_WIDTH = 20;

function lib_control_itemStep(idx, step, max, wrap)
{
    idx += step;
    
    while(idx >= max)
    {
	if(wrap)
	    idx -= max;
	else
	    idx = max - 1;
    }
    while(idx < 0)
    {
	if(wrap)
	    idx += max;
	else
	    idx = 0;
    }

    return idx;
}

function lib_control_focusObject(object, container)
{
    //object is to high up
    if(object.offsetTop < container.scrollTop)
    {
	container.scrollTop = object.offsetTop;
    }
    //object is to low down
    else if(object.offsetTop + object.offsetHeight > container.scrollTop + container.offsetHeight - SCROLLBAR_WIDTH)
    {
	container.scrollTop = object.offsetTop + object.offsetHeight - (container.offsetHeight - SCROLLBAR_WIDTH);
    }
    //object is too far to the left
    if(object.offsetLeft < container.scrollLeft)
    {
	container.scrollLeft = object.offsetLeft;
    }
    //object is too far to the right
    else if(object.offsetLeft + object.offsetWidth > container.scrollLeft + container.offsetWidth - SCROLLBAR_WIDTH)
    {
	container.scrollLeft = object.offsetLeft + object.offsetWidth - (container.offsetWidth - SCROLLBAR_WIDTH);
    }
}

/// This function is supposed to work as the php urldecode as much as possible
function urlDecode(str)
{
    return unescape(str.replace(/\+/g, ' '));
}

function vlc(cmd, val)
{
//    var req = new XMLHttpRequest();
    data = 'cmd=' + escape(cmd);
    if(val !== undefined)
	data += '&val=' + escape(val).replace(/\+/g, '%2b').replace(/-/g, '%2d');
    
/*    req.open('POST', 'vlc.php');
    req.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-length', data.length);
    req.setRequestHeader('Connection', 'close');
    alert(data);
    req.send(data);*/
    var xmlDoc = document.implementation.createDocument("", "", null);
    xmlDoc.async = false;
    xmlDoc.load('vlc.php?' + data);
}
