<?php
/*
YaotGui Videos page


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

require('lib.php');
$showFavs = true;
$path;
if(isset($_GET['path']))
{
   $path = str_replace('\\\'', '\'', $_GET['path']);
   $showFavs = !isInAllowedPath($path);
}

$titlePath;
if($showFavs)
{
   $dir = new LibList('favs', 'favs');
   foreach(Settings::$VIDEO_FAVS as $text => $path)
   {
      $dir->addItem(array('type' => 'dir', 'path' => $path), $text);
   }
	
   $titlePath = 'Videos';
}
else
{
   $directory = new LibDirectory($path, Settings::VIDEO_FILTER);
   $dir = new LibDirectoryImageList('dir', 'dir', 1, 20, 20, $directory,
				    'images/folder.png', 'images/file.png', false, 'images/up.png');
   $titlePath = $dir->getDirectory()->getParentPath() . '/<span class="big">' . $dir->getDirectory()->getName();
}

$dir->sort();

?>
<html>
<head>
<?php
JSLib();
defaultStyles();
?>
<style>
body {background: #000000; color: #ffffff; font-family: Sans-serif; font-size: 20px;
      position: absolute; left: <?php echo TV::LEFT?>px; top: <?php echo TV::TOP?>px; width: <?php echo TV::WIDTH?>px; height: <?php echo TV::HEIGHT?>px; overflow: auto;}
#path {overflow: hidden; white-space: nowrap; position: absolute; left: 25px; top: 2px; width: <?php echo TV::WIDTH-2*25;?>px;}
.dir, .favs {position: absolute; left: 25px; top: 35px; width: <?php echo TV::WIDTH-2*25;?>px; height: <?php echo TV::HEIGHT-2*35;?>px;}
.dir_item, .dir_item_sel {text-align: left;}
.dir_item_img {display: inline; margin-right: 2px; width: 20px; height: 20px;}
</style>
<script src="debug.js"></script>
<script>
    var _fullscreen = false;
var _playing = false;
var _info = false;
var TV_LEFT = <?php echo TV::LEFT?>;
var TV_TOP = <?php echo TV::TOP?>;
var TV_WIDTH = <?php echo TV::WIDTH?>;
var TV_HEIGHT = <?php echo TV::HEIGHT?>;

var _video;

function load()
{
    if(!_debugMode)
    {
	toiEnv.input.addEventListener(toiEnv.input.ON_KEY_DOWN, userinput);

	_video = toiEnv.createMediaPlayer();
	
	BrowserWindow = toiEnv.browserWindow;
	BrowserWindow.enableColorKeying();
	BrowserWindow.setColorKey(0x000001);
	BrowserWindow.setTransparency(BrowserWindow.COLOR_KEY_SOLID_COLOR);

	_video.window.setPosition(TV_LEFT, TV_TOP, TV_WIDTH, TV_HEIGHT);
//	_video.window.setPosition(50, 50, 250, 250);
/*	_video.window.show();

	_video.open('http://<?php echo Settings::VLC_STREAM ?>', 'buftime=500');
	_video.play(1000, -1, -1);*/
    }

    //    hideFullscreen();
}

function unload()
{
    if(!_debugMode)
    {
    _video.window.hide();
    _video.close();
    }
    vlc('stop');
}

function userinput (event)
{
    var key = event.extendedKeyCode;
    event.consume();
    onKey(key);
}

function onKey(key)
{
    try
    {
        switch (key)
        {
	    //boot loader
	case 7733366: //BTN_YELLOW
	    var newLocation = "/iptvgui/initial.html";
	    top.location = newLocation;
	    break;
	case BTN_MENU:
	    top.location = '<?php echo Settings::MAIN_MENU_PATH; ?>';
	    break;
	case BTN_QUESTIONMARK:
	    location.reload();
	    break;
	    /*<?php if($showFavs) { ?>*/
	case BTN_MIDUP:
	    __favs_move(-1, true);
	    break;
	case BTN_MIDDN:
	    __favs_move(1, true);
	    break;
	case BTN_MIDOK:
	    goToDir(__favs_getSelectedValue('path'));
	    break;
	case BTN_PPLUS:
	    __favs_move(-5, 0, false);
	    break;
	case BTN_PMINUS:
	    __favs_move(5, 0, false);
            break;
	    /*<?php } ?>*/
	    /*<?php if(!$showFavs) { ?>*/
	case BTN_MIDUP:
	    if(!_fullscreen)
		__dir_move(-1, 0, true);
	    break;
	case BTN_MIDDN:
	    if(!_fullscreen)
		__dir_move(1, 0, true);
	    break;
	case BTN_MIDOK:
	    if(!_fullscreen)
	    {
		switch(__dir_getSelectedValue('type'))
		{
		case 'file':
		    vlc('new', __dir_getSelectedValue('path'));
		    vlc('play');
		    if(!_debugMode)
		    {
			_video.window.show();
			setTimeout(function ()
				   {
				       _video.open('http://<?php echo Settings::VLC_STREAM ?>', 'buftime=500');
				       _video.play(1000, -1, -1);
				   }, <?php echo Settings::STREAM_DELAY ?>);
		    }
		    _fullscreen = true;
		    _playing = true;
		    break;
		case 'dir':
		    goToDir(__dir_getSelectedValue('path'));
		    break;
		}
	    }
	    else
	    {
		vlc('stop');
		if(!_debugMode)
		{
		    _video.window.hide();
		    _video.close();
		}
		_fullscreen = false;
		_playing = false;
	    }
	    break;
	case BTN_PPLUS:
	    __dir_move(-5, 0, false);
	    break;
	case BTN_PMINUS:
	    __dir_move(5, 0, false);
	    break;
	case BTN_PP:
	    if(_fullscreen)
	    {
		if(_playing)
		{
		    vlc('pause');
		    _playing = false;
		}
		else
		{
		    vlc('seek', '-5sec'); //make sure we don't miss anything ;)
		    vlc('pause');
		    if(!_debugMode)
		    {
			setTimeout(function ()
				   {
//				       _video.close();
//				       _video.open('http://<?php echo Settings::VLC_STREAM ?>', 'buftime=500');
				       _video.play(1000, -1, -1);
				   }, <?php echo Settings::STREAM_DELAY ?>);
		    }
		    _playing = true;
		}
	    }
	    break;
	case BTN_STOP:
	    vlc('stop');
            if(!_debugMode)
            {
		_video.window.hide();
		_video.close();
	    }
            _fullscreen = false;
            _playing = false;
	    break;
	    /*<?php } ?>*/
	case BTN_REW:
	    if(_fullscreen)
	    {
		vlc('seek', '-<?php echo Settings::VLC_SHORT_SKIP ?>');
	    }
	    break;
	case BTN_FOW:
	    if(_fullscreen)
	    {
		vlc('seek', '+<?php echo Settings::VLC_SHORT_SKIP ?>');
	    }
	    break;
	case BTN_SKIPLT:
	    if(_fullscreen)
	    {
		vlc('seek', '-<?php echo Settings::VLC_LONG_SKIP ?>');
	    }
	    break;
	case BTN_SKIPRT:
	    if(_fullscreen)
	    {
		vlc('seek', '+<?php echo Settings::VLC_LONG_SKIP ?>');
	    }
	    break;
	case BTN_0:
	    if(_fullscreen)
	    {
		vlc('seek', '0%');
	    }
	    break;
	case BTN_1:
	    if(_fullscreen)
	    {
		vlc('seek', '10%');
	    }
	    break;
	case BTN_2:
	    if(_fullscreen)
	    {
		vlc('seek', '20%');
	    }
	    break;
	case BTN_3:
	    if(_fullscreen)
	    {
		vlc('seek', '30%');
	    }
	    break;
	case BTN_4:
	    if(_fullscreen)
	    {
		vlc('seek', '40%');
	    }
	    break;
	case BTN_5:
	    if(_fullscreen)
	    {
		vlc('seek', '50%');
	    }
	    break;
	case BTN_6:
	    if(_fullscreen)
	    {
		vlc('seek', '60%');
	    }
	    break;
	case BTN_7:
	    if(_fullscreen)
	    {
		vlc('seek', '70%');
	    }
	    break;
	case BTN_8:
	    if(_fullscreen)
	    {
		vlc('seek', '80%');
	    }
	    break;
	case BTN_9:
	    if(_fullscreen)
	    {
		vlc('seek', '90%');
	    }
	    break;
	default:
	    //	    alert(key);
	    break;
        }
    }
    catch(err)
    {
	alert(err.message);
    }
}

function goToDir(path)
{
    window.location = '?path=' + escape(path);
}

    <?php if(!$showFavs) { ?>

			   <?php } /*!$showFavs*/ ?>

function debugKey(e)
{
    if(!e)
	e = window.event;

    onKey(e.keyCode);
}

document.onkeyup = debugKey;
</script>
</head>
<body onload="load()" onunload="unload()">
    <div id="path"><?php echo $titlePath;?></span></div>

    <?php $dir->printHtml(); ?>
</body>
</html>
