<?php
/*
YaotGui VLM interface


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

require('lib.php');

header("Content-Type: text/xml\n");

$_lastOutput;

function sendReq($req)
{
   global $_lastOutput;
   $_lastOutput = file_get_contents('http://' . Settings::VLC_HTTP . '/requests/status.xml?' . $req);
}

function sendCmd($cmd)
{
   global $_lastOutput;
   $_lastOutput = file_get_contents('http://' . Settings::VLC_HTTP . '/requests/vlm_cmd.xml?command=' . urlencode($cmd));
}

function translatePath($file)
{
   foreach(Settings::$VLC_FOLDER_TRANSLATE as $from => $to)
   {
      $file = str_replace($from, $to, $file);
   }
   
   if(Settings::VLC_FOLDER_TRANSLATE_TO_WIN)
      $file = str_replace('/', '\\\\', $file);

   return $file;
}

function newBroadcast($file)
{
   $file = translatePath($file);
/*   sendCmd('new ' . Settings::VLM_NAME . ' broadcast enabled ' .
	   "input \"$file\" " .
	   'output #transcode{fps=25,vcodec=mp2v,vb=4096,scale=1,acodec=mp2a,ab=512}:std{access=http,mux=ts,dst=' . Settings::VLC_STREAM . '}');*/
}

function del()
{
   sendCmd('del ' . Settings::VLM_NAME);
}

function controlCmd($cmd)
{
   sendCmd('control ' . Settings::VLM_NAME . ' ' . $cmd);
}

function play()
{
   controlCmd('play');
}

function pause()
{
   controlCmd('pause');
}

function stop()
{
   controlCmd('stop');
}


$_cmd = $_REQUEST['cmd'];
$_file = $_REQUEST['file'];

switch($_cmd)
{
   case 'new':
      if($_file && isInAllowedPath($_file))
      {
	 del(); //check existance?
	 newBroadcast($_file);
      }
      break;
   case 'del':
      del();
      break;
   case 'play':
      play();
      break;
   case 'pause':
      pause();
      break;
   case 'stop':
      stop();
      break;
   case 'seek':
      break;
}

echo $_lastOutput;
?>
